diff --git a/src/backend/utils/adt/selfuncs.c b/src/backend/utils/adt/selfuncs.c
index 8dddc5eb93..a3cccc455f 100644
--- a/src/backend/utils/adt/selfuncs.c
+++ b/src/backend/utils/adt/selfuncs.c
@@ -3592,15 +3592,21 @@ estimate_multivariate_ndistinct(PlannerInfo *root, RelOptInfo *rel,
 	/* Determine the attnums we're looking for */
 	foreach(lc, *varinfos)
 	{
+		Var			 *var;
 		GroupVarInfo *varinfo = (GroupVarInfo *) lfirst(lc);
 
 		Assert(varinfo->rel == rel);
 
-		if (IsA(varinfo->var, Var))
-		{
-			attnums = bms_add_member(attnums,
-									 ((Var *) varinfo->var)->varattno);
-		}
+		if (!IsA(varinfo->var, Var))
+			continue;
+
+		var = (Var *) varinfo->var;
+
+		if (!AttrNumberIsForUserDefinedAttr(var->varattno))
+			continue;
+
+		attnums = bms_add_member(attnums,
+								 ((Var *) varinfo->var)->varattno);
 	}
 
 	/* look for the ndistinct statistics matching the most vars */
